restart
loadPackage "MarkedFamiliesWarsaw";
KK = ZZ/101;  R = KK[x,y,z,w];
e=7;
B7 = gens (ideal(x,y,z))^e;
L = trim ideal (B7*random(R^{numColumns B7:0},R^{24:0},Density=>0.2));
betti res L
hilbertPolynomial L,for i from 0 to e list hilbertFunction(i,L)
J = ideal leadTerm L;
betti res L, betti res J
mbL = markedBasis(J,L);

-- tangent space dimensions
time dimTangentSpaceHilbertScheme L
time dimTangentSpaceHilbertScheme J

-- check no negative tangents degree -2
NB7 = for t in flatten entries basis(e,R/J) list sub(t,R);
NB8 = for t in flatten entries basis(e+1,R/J) list sub(t,R);
NB7minus2 = select(NB7, t -> degree(w,t) == 2)
NB8minus2 = select(NB8, t -> degree(w,t) == 2)
negative2 = genericMarkedSetTangentSpace(sort J_*, 
                                         for j in sort J_* list if first degree j == e then NB7minus2 else NB8minus2,
					 VariableBaseName=>"T");
S = ring negative2#0#0;
firstOrderDeformationsMinus2 = {};
for i from 0 to #(negative2#0)-1 do (
    p = position(mbL#1, g -> sub(leadMonomial g, S) == negative2#0#i_(0,0));
    firstOrderDeformationsMinus2 = append(firstOrderDeformationsMinus2, 
	                                  negative2#1#i + sub(mbL#1#p,S) - negative2#0#i);
);
MBminus2 = time markedBasisStarReduction(negative2#0,firstOrderDeformationsMinus2);
TSminus2 = trim ideal for e in (MBminus2#2)_* list leadCoefficient e;
dimTSminus2 = numgens ring TSminus2 - numgens TSminus2


-- negative tangents -1 (expected 636 - 24*12 = 348)
NB7minus1 = select(NB7, t -> degree(w,t) == 1)
NB8minus1 = select(NB8, t -> degree(w,t) == 1)

negative1 = genericMarkedSetTangentSpace(sort J_*,
                                         for j in sort J_* list if first degree j == e then NB7minus1 else NB8minus1,
					 VariableBaseName=>"T");
S = ring negative1#0#0;
firstOrderDeformationsMinus1 = {};
for i from 0 to #(negative1#0)-1 do (
    p = position(mbL#1, g -> sub(leadMonomial g, S) == negative1#0#i_(0,0));
    firstOrderDeformationsMinus1 = append(firstOrderDeformationsMinus1, 
	                                  negative1#1#i + sub(mbL#1#p,S) - negative1#0#i);
);
MBminus1 = time markedBasisStarReduction(negative1#0,firstOrderDeformationsMinus1);
TSminus1 = time trim ideal for e in (MBminus1#2)_* list leadCoefficient e;
dimTSminus1 = numgens ring TSminus1 - numgens TSminus1


