restart
restart
printWidth=123;
loadPackage "MarkedFamiliesWarsaw";
KK = QQ;  R = KK[x_0..x_4,MonomialOrder=>{Position=>Down}];

M = matrix{{x_0,x_1,x_2,x_3,0,0,0,0,0,0,0,0},
           {0,0,0,0,x_0,x_1,x_2,x_3,0,0,0,0},
	   {0,0,0,0,0,0,0,0,x_0,x_1,x_2,x_3},
	   {0,0,x_3,x_0,x_1,0,0,2*x_0+3*x_1+x_2+2*x_3,x_1+x_2,2*x_0+3*x_1+5*x_2+5*x_3,0,0}}
hilbertPolynomial (coker M, Projective=>false) 

gbM = gens gb M
U = leadTerm gbM

headTerms = reverse for i from 0 to numColumns U -1 list U_{i}
markedElements = reverse for i from 0 to numColumns gbM -1 list gbM_{i}

-- tangent space at the quasi-stable module
time dimTangentSpaceQuotScheme image U

-- tangent space at coker M
markedSetTangentSpaceU = genericMarkedSetTangentSpace U;
TS = ring markedSetTangentSpaceU#0#0;
markedSetTangentSpaceM = {};
for i from 0 to #(markedSetTangentSpaceU#0)-1 do (
 j = position(headTerms, ht -> sub(ht,TS) == markedSetTangentSpaceU#0#i);
 markedSetTangentSpaceM = append(markedSetTangentSpaceM,
      sub(markedElements#j,TS) + markedSetTangentSpaceU#1#i - markedSetTangentSpaceU#0#i);
);
first markedSetTangentSpaceU#0, markedElements#3, first markedSetTangentSpaceM 
 
markedBasisTangentSpaceM = markedBasisStarReduction(markedSetTangentSpaceU#0,markedSetTangentSpaceM);
tangentSpaceM = trim ideal for e in (markedBasisTangentSpaceM#2)_* list leadCoefficient e;
dimTangentSpaceRandomM = numgens ring tangentSpaceM - numgens tangentSpaceM
